/*
CONTROL DE RELOJ CUCU
produce sonidos mp3 almacenados en un moduludo de audio YX5300
usa un modulo BLUEPILL STM32F103XX
los sonidos se reproducen desde una tarjeta micro SD que los almacena y son 3:
-sonido de cucu
-sonido de apertura de puerta
-sonido de cierre de puerta
los sonidos se reproducen enviando el comando respectivo en formato HEX
se tomo la señal de suicheo que acciona la caja de sonido de un reloj de pendulo TIKROUND y se le filtro el rebote del microsuiche
para asi conformar un pulso Bajo que dura mas de 30ms.
Este pulso horario marca la hora dedel CUCU y verifica que dura mas de 30ms procede a hacer sonar el cucu con todo su acionamiento respectivo
el conteo se hace de 1 a 12, se puede incorporar una señal proveniente de una foto resistencia para que el cucu no suene en la oscuridad
*/


#include "mbed.h"
#include "DebouncedIn.h"
int i=0,j=0,k=0;

//...............salidas el sistema.....................
DigitalOut led(PC_13);// LED INDICADOR
DigitalOut m1(PB_15);// motor casita
DigitalOut m2(PB_14);// motor casita
DigitalOut m3(PB_13);// plunger pajaro
DigitalOut m4(PB_12);// plunger pajaro
//............entradas ........al sistema

DebouncedIn button(PC_15);
Serial bird(PB_6,PB_7); //Configura puerto UART de la BLUEPILL

//comandos del modulo YX5300 PARA HACER SONAR EL CUCU y otras cosas
const char cucu1[8]={0x7E, 0xFF, 0x06, 0x03, 0x00, 0x00, 0x01, 0xEF};//   CUCU
const char openP[8]={0x7E, 0xFF, 0x06, 0x03, 0x00, 0x00, 0x02, 0xEF};//   ABRIR PUERTA
const char closeP[8]={0x7E, 0xFF, 0x06, 0x03, 0x00, 0x00, 0x03, 0xEF};//  CERRAR PUERTA
const char slep[8]={0x7E, 0xFF, 0x06, 0x0A, 0x00, 0x00, 0x00, 0xEF};//    modo sleep
const char awake[8]={0x7E, 0xFF, 0x06, 0x0B, 0x00, 0x00, 0x00, 0xEF};//   despertar el modulo

//...entrar en modo sleep para ahorar bateria........................
//.....................SLEEP.........................................
void slp(){
    for(i=0;i<8;i++){
    bird.printf("%c",slep[i]);    
                    }
          }
       
//.....................AWAKE.........despierta el modulo...............
void awak(){
    for(i=0;i<8;i++){
    bird.printf("%c", awake[i]);    
                    }
           } 
      
//.....................CLOSE.......sonido..............................
void closed(){
    for(i=0;i<8;i++){
    bird.printf("%c", closeP[i]);    
                    }
             } 
//.....................OPEN........sonido..............................
void open(){
    for(i=0;i<8;i++){
    bird.printf("%c", openP[i]);    
                    }
           } 

//.....................SONIDOS DEL CUCU SEGUN LA HORA...............
// esta funcion produce el sonido del cucu segun la hora se encarga de accionar todos los mecanismos del cucu
// como la puerta y el pajaro, h es el valor de la hora de 1-12
void cucu(int h){
//.....................abrir la puerta..............................
    awak();
    wait(1);
    m1=1;
    m2=0;
    open();//sonido abrir sonido de puerta chirriando..
    wait(1);
      
//.................................................................. 
    m1=0;
    m2=0;
//....termina apertura de puerta    
     for(j=0;j<k;j++){//
//.....................acciona plunger pico.........................
     m3=1;
     m4=0;
     for(i=0;i<8;i++){
     bird.printf("%c", cucu1[i]);
                     }
     wait_ms(200);
     m3=0;
     m4=0;                
     wait_ms(800);                         
//...............se desenergiza el plunger pico.....................
     
                    }
                        
//..............se sierra la puerta..termino de sonar el cucu.......
    m1=0;
    m2=1;
    closed();//...sonido de puerta cerrada...........................
    wait(1);
    m1=0;
    m2=0;  //desenergiza puerta para ahorrar bateria................
    slp();
    wait(1);
    
       }                 

int main( ){
    led=0;
    wait(1);
    led=1;
    m1=0;
    m2=0;
    m3=0;
    m4=0;
   
    while(1) {
             if (button.falling()){
               ++k;  
                if(k>12){
                       k=1;
                       }
                cucu(k);  
                                   }
             
                                           
             }//while
}         //main


